%%%%
%% LBlock
%%%%
clear all;
source('LBlock_lib.m');
%%%%
%% Example of test vectors
%%%%
MSG='0000000000000000';
Key='00000000000000000000';
%MSG='0123456789abcdef';
%Key='0123456789abcdeffedc';

s=create_state(MSG);
K=create_state_bin(Key);

%%%%
%%  Encryption
%%%%
X(1,:)=s(9:16);
X(2,:)=s(1:8);
for i=3:34
  Ki=create_state_k(K(1:32));
  if i<34
    K=keyschedule(K, i-2);
  end
  X(i,:)=bitxor(f(X(i-1,:), Ki),[X(i-2,3:end) X(i-2,1:2)]);
end
C=[X(33,:) X(34,:)];
dec2hex(C)

clear X;
X(34,:)=C(9:16);
X(33,:)=C(1:8);
%%%%
%% Decryption
%%%%
for i=32:-1:1
  i
  Ki=create_state_k(K(1:32))
  if i>1
    K=keyschedule_d(K, i-1);
  end
  t=bitxor(f(X(i+1,:), Ki), X(i+2,:));
  X(i,:)=[t(7:8) t(1:6)];
end
M=[X(2,:) X(1,:)];
dec2hex(M)